inicialitzaci rellotge

#include <16F877.H>
#include <DS1302.h>
int dia, mes, any,hora,minut,diasem;
void main(){
rtc_init();
llegir_dades(dia,mes,any,hora,minut,diasem)
//Es converteix el valors a BCD
dia=dia+abs(dia/10)*6;
mes=mes+abs(mes/10)*6;
any=any+abs(anio/10)*6;
hora=hora+abs(hora/10)*6;
minut=minut+abs(minuto/10)*6;
diasem=diasem+abs(diasem/10)*6;
rtc_set_datetime(dia,mes,any,diasem,hora,minut);
}

Programa principal
#include <16F877.H>
#use delay(clock=12000000) // cristall de 12MHz
#use rs232(baud=9600,xmit=PIN_Bo,rcv=Pin_B1,bits=8,parity=n))
#include <DS1307.h>
#include <math.h>
#include <calculo.h>
#include <llegir_inclinometre_rot.h>
#include <llegir_inclinometre_inc.h>
#include <llegir_rellotge.h>
#include <llegir_num_seguidor.h>
#include <calcular_angle.h>


BYTE day, mth, year, dow, hr, min, sec;
float hora_decimal, angle_teor, angle_real, angle_teormenys, angle_teormes, 
int num_seguidor;
void main() {
set_tris_c(11111001); //RC1 y RC2 sortida de dades
SETUP_TIMER_2(T2_DIV_BY_16,255,1);
do{
//Lectura de la hora: FUNCI  llegir_rellotge
llegir_rellotge(day,mth,year,dow,hr,min,sec);
llegir_num_seguidor(num_seguidor)

if (hr<5)
{
do{
RD0=1//Activem el relle 1
RD1=1//Activem el relle 2 

//Clcul de langle teric: funci calcul_angle
angle_teor=calcular_angle(hr,min,sec,day,mth,year);
angle_teormes=angle_teor+2.0;
angle_teormenys=angle_teor-2.0;
//Angle donat per els inclinometres
//Funci  llegir_inclinometres
angle_real=llegir_inclinometre_inc();
//Establecimiento del PWM
if((angle_teormenys<=angle_real)&&(angle_real<=angle_teormes)){
//si los angulos son iguales el motor tiene que estar parado
//PWM duty cycle es el tiempo q est en 1
SET_PWM1_DUTY(255);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(255);
SETUP_CCP2(CCP_PWM);
}else if(angle_real<angle_teormenys){
//El motor ha de girar per aconseguir langle teric
SET_PWM1_DUTY(10);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(255);
SETUP_CCP2(CCP_PWM);
}else if(angle_real>angle_teormes){
SET_PWM1_DUTY(255);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(10);
SETUP_CCP2(CCP_PWM);
}
}while(angle_rea l== angle_teor);

//Clcul de langle teric: funci calcul_angle
angle_teor=calcular_angle(hr,min,sec,day,mth,year);
angle_teormes=angle_teor+2.0;
angle_teormenys=angle_teor-2.0;
//Angle donat per els inclinometres
//Funci  llegir_inclinometres
angle_real=llegir_inclinometre_rot();
//Establecimiento del PWM
if((angle_teormenys<=angle_real)&&(angle_real<=angle_teormes)){
//si los angulos son iguales el motor tiene que estar parado
//PWM duty cycle es el tiempo q est en 1
SET_PWM1_DUTY(255);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(255);
SETUP_CCP2(CCP_PWM);
}else if(angle_real<angle_teormenys){
//El motor ha de girar per aconseguir langle teric
SET_PWM1_DUTY(10);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(255);
SETUP_CCP2(CCP_PWM);
}else if(angle_real>angle_teormes){
SET_PWM1_DUTY(255);
SETUP_CCP1(CCP_PWM);
SET_PWM2_DUTY(10);
SETUP_CCP2(CCP_PWM);
}
delay_ms(50);
enviar_dades(angle_teor,inclinacio,num_seguidor)
delay_ms(50);
}while(true);
}

llegir_rellotge(byte& day, byte& mth, byte& year, byte& dow,byte&hr, byte&min, byte& sec)
void llegir_rellotge(BYTE& day, BYTE& mth, BYTE& year, BYTE& dow, BYTE& hr,
BYTE& min, BYTE& sec){
rtc_get_date(day,mth,year,dow);
rtc_get_time(hr,min,sec);
//Conversi binari a BCD
day=day-(day/16)*6;
mth=mth-(mth/16)*6;
year=year-(year/16)*6;
hr=hr-(hr/16)*6;
min=min-(min/16)*6;
sec=sec-(sec/16)*6;
}

calcul_angle() 
float lon; // longitud
float ang_opt, ang_opt_r;
float k, aux; //variables 
float hora_dec;
float llegir_rellotge(BYTE h,BYTE min, BYTE sec, BYTE dia, BYTE mes, BYTE any){
//angle horari
hora_dec=h;
aux=min;
hora_dec=hora_dec+aux/60.0;
aux=sec;
hora_dec=hora_dec+aux/3600.0;
hora_dec=hora_dec-(14+lon/15);
//ngle optim de gir
ang_opt_r=hora_dec*(360/24);
k=45; //mxim angle
//Comprovaci que langle calculat no superi el mxim angle
if((ang_opt_r<k)&&(ang_opt_r>(-k))){
ang_opt=ang_opt_r;
}else if(ang_opt_r>=k){
ang_opt=k; //Mxim gir a lEst
}else if(ang_opt_r<=(-k)){
ang_opt=-k; //Mxim gir a lOest
}
return ang_opt;
}


calcul_inclinacio() 
float a, b; //variables
float inclinacio;
float llegir_rellotge(BYTE h,BYTE min, BYTE sec, BYTE dia, BYTE mes, BYTE any){
if((mes>2) &&(mes<6))
{inclinacio=45
}else if((mes>=6) &&(mes<9)) {
inclinacio=30
}else if((mes>=9) &&(mes<2)) {
inclinacio=60
}
return inclinacio;
}

Llegir inclinometre_rot()
float voltatge, angle, auxi;
byte entrada;
float llegir_inclinometre_rot() {
set_tris_a(0xFF); //porta como entrada
setup_port_a(RA0_ANALOG); //Entrada analgica per RA0
setup_adc(adc_clock_internal);
set_adc_channel(0);
delay_us(10);
entrada=read_adc();
auxi=entrada;
voltage=auxi;
angle=voltaje/0.0396;
return angle;
}

Llegir inclinometre_inc()
float voltatge, angle, auxi;
byte entrada;
float llegir_inclinometre_inc() {
set_tris_a(0xFF); //porta como entrada
setup_port_a(RA1_ANALOG); //Entrada analgica per RA1
setup_adc(adc_clock_internal);
set_adc_channel(0);
delay_us(10);
entrada=read_adc();
auxi=entrada;
voltage=auxi;
angle=voltaje/0.0396;
return angle;
}

enviar_dades(angle_teor,num_seguidor)
{
set_tris_a(0xFF); //PORTA com entrada
set_tris_b(0x02); //RB1 entrada, els altre pins sortida

puts(angle_teor,\n)
puts(inclinacio,\n)
putsc(num_seguidor,\n)
puts( ,\n)
}

llegir_dades()
int dia,mes,any,hora,minut,diasem;

 
{
set_tris_a(0xFF); //PORTA com entrada
set_tris_b(0x02); //RB1 entrada, els altre pins sortida

get(dia,\n)
get(mes,\n)
get(any,\n)

get(hora,\n)
get(minut,\n)
get(diasem,\n)

}
